# Spectator
gamemode spectator @a[team=Spec,gamemode=!spectator]

# Respawning
execute as @a[scores={Death=1..}] at @s run function bannerbattle:phase3/death
execute as @a[scores={respawnTimer=1..}] at @s run function bannerbattle:phase3/respawn_timer

# Tips
execute if score timer vars matches 19400 run function bannerbattle:phase3/tip
execute if score timer vars matches 16400 run function bannerbattle:phase3/tip
execute if score timer vars matches 14000 run function bannerbattle:phase3/tip

# Stealing blue flag
execute at @e[tag=bluey] as @a[team=red,distance=..1] if entity @e[tag=bnice] run function bannerbattle:phase3/blue_stolen
execute as @a[scores={respawnTimer=1..},tag=bstealer] at @s run function bannerbattle:phase3/drop_blue
execute unless entity @e[tag=bnice] unless entity @a[tag=bstealer] run function bannerbattle:phase3/drop_blue 

# Stealing red flag
execute at @e[tag=redy] as @a[team=blue,distance=..1] if entity @e[tag=rnice] run function bannerbattle:phase3/red_stolen
execute as @a[scores={respawnTimer=1..},tag=rstealer] at @s run function bannerbattle:phase3/drop_red
execute unless entity @e[tag=rnice] unless entity @a[tag=rstealer] run function bannerbattle:phase3/drop_red

# Flag warnings
scoreboard players add flagWarning vars 1
execute if score flagWarning vars matches 10.. run scoreboard players set flagWarning vars 0
execute if score flagWarning vars matches 0 if entity @a[tag=bstealer] run title @a[team=blue] actionbar {"text":"FLAG STOLEN!","color":"black","bold":true}
execute if score flagWarning vars matches 0 if entity @a[tag=rstealer] run title @a[team=red] actionbar {"text":"FLAG STOLEN!","color":"black","bold":true}
execute if score flagWarning vars matches 5 if entity @a[tag=bstealer] run title @a[team=blue] actionbar {"text":"FLAG STOLEN!","color":"dark_red","bold":true}
execute if score flagWarning vars matches 5 if entity @a[tag=rstealer] run title @a[team=red] actionbar {"text":"FLAG STOLEN!","color":"dark_red","bold":true}

# Entire team leaves
execute unless entity @a[team=red] unless entity @a[scores={endGame=0}] run function bannerbattle:entire_team_left
execute unless entity @a[team=blue] unless entity @a[scores={endGame=0}] run function bannerbattle:entire_team_left
execute as @a[scores={endGame=1..}] run function bannerbattle:end_game
execute if entity @a[team=red] if entity @a[team=blue] if entity @a[scores={endGame=0}] run scoreboard players reset @a endGame

# Players out of bounds
tag @a remove ok
tag @a[scores={respawnTimer=1..}] add ok
execute positioned -8 22 -36 as @a[dx=30,dy=20,dz=80] run tag @s add ok
kill @a[gamemode=adventure,tag=!ok]

# Music
scoreboard players remove music vars 1
execute if score music vars matches ..0 run stopsound @a player
execute if score music vars matches ..0 as @a at @s run playsound music_disc.stal player @s ~ ~ ~ 10000 1 1
execute if score music vars matches ..0 run scoreboard players set mnusic vars 3100

# Repower
scoreboard players add powerTime vars 1
execute if score powerTime vars matches 1600.. run function bannerbattle:phase3/blessings_refill
execute if score blessingTitle vars matches 1.. run function bannerbattle:phase3/blessing_refill_title

# Items
tag @e[type=item,nbt={Item:{tag:{Zomw:1}},Age:1s},tag=!ZombieSpawn] add ZombieSpawn
tag @e[type=item,nbt={Item:{tag:{End:1}},Age:1s},tag=!smite] add smite
tag @e[type=item,nbt={Item:{tag:{TimeS:1}},Age:1s},tag=!Kron] add Kron
tag @e[type=item,nbt={Item:{tag:{LoveS:1}},Age:1s},tag=!Love] add Love
tag @e[type=item,nbt={Item:{tag:{SleepS:1}},Age:1s},tag=!Sleeping] add Sleeping
tag @e[type=item,nbt={Item:{tag:{JumpS:1}},Age:1s},tag=!Jumpy] add Jumpy

tag @e[type=item,nbt={Item:{id:"minecraft:stick"}},tag=!ohnoes.stick] add ohnoes.stick
execute at @e[type=item,tag=ohnoes.stick] run give @p[tag=twiggy] minecraft:stick{display:{Name:'{"text":"Stick of Yssom"}',Lore:['{"text":"A stick that was meant to repel all invaders"}']},Enchantments:[{id:"knockback",lvl:2}],HideFlags:63,Tig:1b} 1
execute as @e[type=item,tag=ohnoes.stick] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:bow"},Age:1s},tag=!ohnoes.bow] add ohnoes.bow
execute at @e[type=item,tag=ohnoes.bow] run give @p[tag=zephy] bow{Tags:["bowz"],Unbreakable:1,display:{Name:'{"text":"Bow of Zephyr"}',Lore:['{"text":"Let the wind carry you..."}']},Enchantments:[{}]} 1
execute as @e[type=item,tag=ohnoes.bow] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:stone_sword",tag:{Normalt:1b}}},tag=!ohnoes.sword] add ohnoes.sword
execute at @e[type=item,tag=ohnoes.sword] run give @p minecraft:stone_sword{CanDestroy:["#bannerbattle:valid_blocks"],HideFlags:63,Normalt:1b,Unbreakable:1,Enchantments:[{id:"sharpness",lvl:1}]} 1
execute as @e[type=item,tag=ohnoes.sword] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:crossbow",tag:{Normalt:1b}}},tag=!ohnoes.crossbow] add ohnoes.crossbow
execute at @e[type=item,tag=ohnoes.crossbow] run give @p minecraft:crossbow{CanDestroy:["#bannerbattle:valid_blocks"],HideFlags:63,Enchantments:[{id:"quick_charge",lvl:2}],Unbreakable:1, Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.crossbow] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:wooden_pickaxe",tag:{Normalt:1b}}},tag=!ohnoes.pickaxe] add ohnoes.pickaxe
execute at @e[type=item,tag=ohnoes.pickaxe] run give @p minecraft:wooden_pickaxe{CanDestroy:["#bannerbattle:valid_blocks"],Unbreakable:1,display:{Name:'{"text":"Pick of Blockiness"}'},Enchantments:[{id:"efficiency",lvl:1}],HideFlags:63,Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.pickaxe] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:wooden_axe",tag:{Normalt:1b}}},tag=!ohnoes.axe] add ohnoes.axe
execute at @e[type=item,tag=ohnoes.axe] run give @p minecraft:wooden_axe{CanDestroy:["#bannerbattle:valid_blocks"],Unbreakable:1,display:{Name:'{"text":"A Rather Blunt Axe"}'},Enchantments:[{}],HideFlags:63,Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.axe] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:wooden_shovel",tag:{Normalt:1b}},},tag=!ohnoes.shovel] add ohnoes.shovel
execute at @e[type=item,tag=ohnoes.shovel] run give @p minecraft:wooden_shovel{CanDestroy:["#bannerbattle:valid_blocks"],Unbreakable:1,display:{Name:'{"text":"Dirt Killer"}'},Enchantments:[{}],HideFlags:63,Normalt:1b} 1
execute as @e[type=item,tag=ohnoes.shovel] run kill @s

#Heph items
tag @e[type=item,nbt={Item:{id:"minecraft:iron_sword",tag:{Hepht:1b}}},tag=!ohnoes.swordh] add ohnoes.swordh
execute at @e[type=item,tag=ohnoes.swordh] run give @p minecraft:iron_sword{CanDestroy:["#bannerbattle:valid_blocks"],HideFlags:63,display:{Name:'{"text":"Ancient Blade"}',Lore:['{"text":"Forged to be stronger"}']},Enchantments:[{id:"sharpness",lvl:1}],Unbreakable:1,Hepht:1b} 1
execute as @e[type=item,tag=ohnoes.swordh] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:crossbow",tag:{Hepht:1b}}},tag=!ohnoes.crossbowh] add ohnoes.crossbowh
execute at @e[type=item,tag=ohnoes.crossbowh] run give @p minecraft:crossbow{CanDestroy:["#bannerbattle:valid_blocks"],HideFlags:63,display:{Name:'{"text":"Ancient Crossbow"}',Lore:['{"text":"Forged to be stronger"}']},Enchantments:[{id:"quick_charge",lvl:2},{id:"piercing",lvl:2}],Unbreakable:1,Hepht:1b} 1
execute as @e[type=item,tag=ohnoes.crossbowh] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:stone_pickaxe",tag:{Hepht:1b}}},tag=!ohnoes.pickaxeh] add ohnoes.pickaxeh
execute at @e[type=item,tag=ohnoes.pickaxeh] run give @p minecraft:stone_pickaxe{CanDestroy:["#bannerbattle:valid_blocks"],HideFlags:63,display:{Name:'{"text":"Ancient Pick"}',Lore:['{"text":"Forged to be stronger"}']},Enchantments:[{id:"efficiency",lvl:2}],Unbreakable:1,Hepht:1b} 1
execute as @e[type=item,tag=ohnoes.pickaxeh] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:stone_axe",tag:{Hepht:1b}}},tag=!ohnoes.axeh] add ohnoes.axeh
execute at @e[type=item,tag=ohnoes.axeh] run give @p minecraft:stone_axe{HideFlags:63,CanDestroy:["#bannerbattle:valid_blocks"],display:{Name:'{"text":"Ancient Axe"}',Lore:['{"text":"Forged to be stronger"}']},Enchantments:[{id:"efficiency",lvl:2}],Unbreakable:1,Hepht:1b} 1
execute as @e[type=item,tag=ohnoes.axeh] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:stone_shovel",tag:{Hepht:1b}}},tag=!ohnoes.shovelh] add ohnoes.shovelh
execute at @e[type=item,tag=ohnoes.shovelh] run give @p minecraft:stone_shovel{HideFlags:63,display:{Name:'{"text":"Ancient Shovel"}',Lore:['{"text":"Forged to be stronger"}']},Enchantments:[{d:"efficiency",lvl:1}],CanDestroy:["#bannerbattle:valid_blocks"],Unbreakable:1,Hepht:1b} 1
execute as @e[type=item,tag=ohnoes.shovelh] run kill @s

tag @e[type=item,nbt={Item:{id:"minecraft:shield",tag:{Hepht:1b}}},tag=!ohnoes.shieldh] add ohnoes.shieldh
execute at @e[type=item,tag=ohnoes.shieldh] run give @p minecraft:shield{Damage:320,HideFlags:63,display:{Name:'{"text":"Ancient Shield"}',Lore:['{"text":"Forged"}']},Enchantments:[{}],Hepht:1b,Unbreakable:1,CanDestroy:["#bannerbattle:valid_blocks"]} 1
execute as @e[type=item,tag=ohnoes.shieldh] run kill @s

#kill @e[type=item,nbt={Item:{id:"minecraft:stone_sword",Count:1b}}]
#kill @e[type=item,nbt={Item:{id:"minecraft:crossbow",Count:1b}}]
#kill @e[type=item,nbt={Item:{id:"minecraft:stick",Count:1b,tag:{Tig:1b}}}]
kill @e[type=item,nbt={Item:{id:"minecraft:arrow",Count:1b,tag:{Tig:1b}}}]
item replace entity @a[gamemode=adventure] inventory.8 with arrow

# Particles
particle minecraft:soul_fire_flame -1 32.2 8 0.1 0.15 0.1 0 1
particle minecraft:soul_fire_flame 17 32.2 8 0.1 0.15 0.1 0 1

# Skeleton Team Spawns
execute at @e[tag=ZombieSpawn] run tag @p add zomz
execute at @e[tag=ZombieSpawn] if entity @p[team=blue,tag=zomz] run summon skeleton ~ ~1 ~ {PersistenceRequired:1,ArmorItems:[{},{},{},{id:"iron_helmet",Count:1b}],ArmorDropChances:[0.085F,0.085F,0.085F,0.0F],HandItems:[{id:"iron_sword",Count:1b},{}],HandDropChances:[0.0F,0.085F],Attributes:[{Name:"generic.max_health",Base:10}],Health:30.0f,CanPickUpLoot:1b,Team:"blue",Tags:[skele1]}
execute at @e[tag=ZombieSpawn] if entity @p[team=red,tag=zomz] run summon skeleton ~ ~1 ~ {PersistenceRequired:1,HandItems:[{id:"iron_sword",Count:1b},{}],HandDropChances:[0.0F,0.085F],Attributes:[{Name:"generic.max_health",Base:10}],Health:30.0f,CanPickUpLoot:1b,Team:"red",Tags:[skele1],ArmorItems:[{},{},{},{id:"iron_helmet",Count:1b}],ArmorDropChances:[0.085F,0.085F,0.085F,0.0F]}
kill @e[tag=ZombieSpawn]
tag @a[tag=zomz] remove zomz

# Rubber Ducky Smite
execute at @e[tag=smite] run tag @p add duckd
execute at @e[tag=smite] if entity @p[team=blue,tag=duckd] run effect give @p[team=red] minecraft:instant_damage 1 25
execute at @e[tag=smite] if entity @p[team=red,tag=duckd] run effect give @p[team=blue] minecraft:instant_damage 1 25
execute at @e[tag=smite] run playsound minecraft:entity.lightning_bolt.thunder master @a ~ ~ ~ 10000
execute at @e[tag=smite] run tellraw @a ["",{"selector":"@p[tag=duck]","color":"black"},{"text":" has summoned the power of the Rubber Ducky!","color":"gold"}]
kill @e[tag=smite]
tag @a[tag=duckd] remove duckd

# Kronos
execute at @e[tag=Kron] run tag @p[tag=slowt] add Kronk
execute at @e[tag=Kron] if entity @p[team=blue,tag=Kronk] run effect give @a[team=red] minecraft:slowness 8 3 true
execute at @e[tag=Kron] if entity @p[team=red,tag=Kronk] run effect give @a[team=blue] minecraft:slowness 8 3 true
execute at @e[tag=Kron] run tellraw @a ["",{"selector":"@p[tag=slowt]","color":"green"},{"text":" has summoned the power of Kronos!","color":"gold"}]
kill @e[tag=Kron]
tag @a[tag=Kronk] remove Kronk

# Aphrodite
execute at @e[tag=Love] run tag @p[tag=aphrodite] add Lover
execute at @e[tag=Love] if entity @p[team=blue,tag=Lover] run effect give @a[team=red] minecraft:weakness 8 3 true
execute at @e[tag=Love] if entity @p[team=red,tag=Lover] run effect give @a[team=blue] minecraft:weakness 8 3 true
execute at @e[tag=Love] run tellraw @a ["",{"selector":"@p[tag=slowt]","color":"green"},{"text":" has summoned the power of Aphrodite!","color":"light_purple"}]
kill @e[tag=Love]
tag @a[tag=Lover] remove Lover

# Hypnos
execute at @e[tag=Sleeping] run tag @p[tag=sleep] add Sleepy
execute at @e[tag=Sleeping] if entity @p[team=blue,tag=Sleepy] run effect give @a[team=red] minecraft:blindness 5 3 true
execute at @e[tag=Sleeping] if entity @p[team=red,tag=Sleepy] run effect give @a[team=blue] minecraft:blindness 5 3 true
execute at @e[tag=Sleeping] run tellraw @a ["",{"selector":"@p[tag=sleep]","color":"green"},{"text":" has summoned the power of Hypnos!","color":"black"}]
kill @e[tag=Sleeping]
tag @a[tag=Sleepy] remove Sleepy

# Jump boost
execute at @e[tag=Jumpy] run tag @p[tag=jump] add Jumping
execute at @e[tag=Jumpy] run effect give @p minecraft:jump_boost 8 2 true
execute at @e[tag=Jumpy] run tellraw @a ["",{"selector":"@p[tag=jump]","color":"green"},{"text":" has summoned the power of Brizzlebit!","color":"dark_green"}]
kill @e[tag=Jumpy]
tag @a[tag=Jumping] remove Jumping

# Blessings particles
execute at @a[tag=sleep] run particle dust 0.01 0.0 0.0 1 ~ ~2 ~
execute at @a[tag=aphrodite] run particle dust 1 0.4 0.4 1 ~ ~2 ~
execute at @a[tag=zephy] run particle dust 0.3 0.7 1 1 ~ ~2 ~ 
execute at @a[tag=twiggy] run particle dust 1 0.7 1 1 ~ ~2 ~ 
execute at @a[tag=jump] run particle dust 0.2 1 .2 1 ~ ~2 ~ 
execute at @a[tag=slowt] run particle dust 0.7 .7 .7 1 ~ ~2 ~ 
execute at @a[tag=ares] run particle dust 0.7 .2 .2 1 ~ ~2 ~ 
execute at @a[tag=duck] run particle dust 0.9 0.09 1 1 ~ ~2 ~
execute at @a[tag=heph] run particle dust 1 1 1 1 ~ ~2 ~

# Fallen items
execute as @e[type=item,nbt={Item:{id:"minecraft:shroomlight"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:soul_sand"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:dirt"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:end_stone"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:yellow_wool"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:red_wool"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:blue_wool"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:nether_bricks"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:oak_planks"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:oak_fence"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:cobblestone"}},tag=!fallen] run function bannerbattle:process_fallen_item
execute as @e[type=item,nbt={Item:{id:"minecraft:birch_planks"}},tag=!fallen] run function bannerbattle:process_fallen_item

# Kill landed arrows
kill @e[type=arrow,nbt={inGround:1b}]

# Place blocks
execute as @a[scores={place0=1..}] run function bannerbattle:place_block
execute as @a[scores={place1=1..}] run function bannerbattle:place_block
execute as @a[scores={place2=1..}] run function bannerbattle:place_block
execute as @a[scores={place3=1..}] run function bannerbattle:place_block
execute as @a[scores={place4=1..}] run function bannerbattle:place_block
execute as @a[scores={place5=1..}] run function bannerbattle:place_block
execute as @a[scores={place6=1..}] run function bannerbattle:place_block
execute as @a[scores={place7=1..}] run function bannerbattle:place_block
execute as @a[scores={place8=1..}] run function bannerbattle:place_block
execute as @a[scores={place9=1..}] run function bannerbattle:place_block
execute as @a[scores={place10=1..}] run function bannerbattle:place_block

# Flag captured (WIN)
execute if entity @e[tag=rnice] at @e[tag=redy] if entity @a[tag=bstealer,distance=..1] run function bannerbattle:phase3/red_win 
execute if entity @e[tag=bnice] at @e[tag=bluey] if entity @a[tag=rstealer,distance=..1] run function bannerbattle:phase3/blue_win 

# Time
scoreboard players remove timer vars 1
scoreboard players operation timeSeconds vars = timer vars
scoreboard players operation timeSeconds vars /= 20 const
scoreboard players add timeSeconds vars 1
scoreboard players operation Time: timeDisplay = timeSeconds vars
execute if score timer vars matches 1200 run function bannerbattle:timer_title
execute if score timer vars matches 600 run function bannerbattle:timer_title
execute if score timer vars matches 200 run function bannerbattle:timer_title
execute if score timer vars matches 0 run function bannerbattle:phase3/end_in_tie