scoreboard players set timer vars 0
scoreboard players set phase vars -1

# Text
title @a times 10 40 10
title @a title ""
tellraw @a {"text":"Warning! Possible Lag Spike!","color":"gold"}

# Player handling
tp @a 11.5 209.5 3.5 180 0
team join Spec @a
gamemode adventure @a
clear @a
effect clear @a
spawnpoint @a 8 216 22 180
xp set @a 0 levels
xp set @a 0 points
stopsound @a player
effect give @s instant_health 1 100 true
effect give @s resistance 1000000 100 true
effect give @s saturation 1000000 100 true
effect give @s weakness 1000000 100 true
bossbar set mobs visible false

# Structures
fill -7 20 -33 28 29 57 air replace #bannerbattle:valid_blocks
fill -7 30 -33 28 39 57 air replace #bannerbattle:valid_blocks
fill -7 40 -33 28 49 57 air replace #bannerbattle:valid_blocks
clone 15 120 158 15 120 158 -10 27 -6 replace force
setblock -11 27 -6 redstone_block
fill -11 27 -6 -10 27 -6 air
fill 0 37 20 14 33 -2 air
fill 1 38 7 1 38 9 air
execute as @e[tag=settings] run data merge entity @s {CustomNameVisible:0}
clone 15 123 148 15 123 150 20 217 0

# Scores
scoreboard players reset * kills
scoreboard players add @a[tag=rstealer] steal 1
scoreboard players add @a[tag=bstealer] steal 1
scoreboard players reset * balance
scoreboard objectives setdisplay sidebar 
scoreboard players reset * endGame
scoreboard players set blueWin vars 0
scoreboard players set redWin vars 0
scoreboard players set redReady vars 0
scoreboard players set blueReady vars 0
scoreboard players reset fireworks vars

# Tags
tag @a remove redt
tag @a remove bluet
tag @a remove rstealer
tag @a remove bstealer
tag @a remove duck
tag @a remove sleep
tag @a remove heph
tag @a remove ares
tag @a remove slowt
tag @a remove jump
tag @a remove twiggy
tag @a remove zephy
tag @a remove aphrodite
tag @a remove blessing
tag @a remove phase.1
tag @a remove phase.2
tag @a remove Parkour
tag @a add lobby
tag @a remove ok

# Other entities
tp @e[tag=galactic] 20.5 216.3 9.8 -179.9 0
tp @e[tag=galac] 16 121 146
kill @e[tag=bcool]
kill @e[tag=rcool]
kill @e[type=skeleton]
kill @e[tag=z]
kill @e[type=item,tag=!save]
summon item 2 217 8 {Item:{id:"minecraft:ghast_tear",Count:1b,tag:{HideFlags:7,Rubb:1}},CustomName:'{"text":"Blessing of the RubberDucky God"}',PickupDelay:32767s,Tags:["rubby","bless"],Age:-32768s,CustomNameVisible:1b}

# Items
item replace entity @p[tag=bstealer] armor.head with diamond 1
item replace entity @p[tag=rstealer] armor.head with diamond 1
item replace entity @a[tag=chestd] armor.chest with minecraft:diamond_chestplate{Enchantments:[{id:"minecraft:binding_curse",lvl:1}],Unbreakable:1b,HideFlags:63,display:{Name:'"THE S.H.I.R.T."'}} 1
item replace entity @a[tag=pink] armor.feet with minecraft:leather_boots{Unbreakable:1,HideFlags:63,display:{color:13062738,Name:'{"text":"Pink Feet Hats"}'}} 1
item replace entity @a[tag=aqua] armor.feet with minecraft:leather_boots{Unbreakable:1,HideFlags:63,display:{color:56831,Name:'{"text":"Blue Feet Hats"}'}} 1
item replace entity @a[tag=shinyb] armor.feet with minecraft:golden_boots{Enchantments:[{id:"minecraft:binding_curse",lvl:1}],Unbreakable:1,HideFlags:63,display:{Name:'{"text":"Super Shiny Feet Hats"}'}} 1
item replace entity @a[tag=shinyc] armor.chest with minecraft:golden_chestplate{Enchantments:[{id:"minecraft:binding_curse",lvl:1}],Unbreakable:1,HideFlags:63,display:{Name:'{"text":"Shiny Shirt"}'}} 1
item replace entity @a[tag=chestt] armor.chest with minecraft:chainmail_chestplate{Enchantments:[{id:"minecraft:binding_curse",lvl:1}],Unbreakable:1,HideFlags:63,display:{Name:'{"text":"Trendy Shirt"}'}} 1