scoreboard players set phase vars 2
scoreboard players operation timer vars = phase2Time vars

# Text
title @a subtitle ["",{"text":"Phase 2 -","color":"aqua"},{"text":" "},{"text":"Reinforce","bold":true,"color":"gold"}]
title @a title ""
tellraw @a ["",{"text":"GalacticDuck: ","bold":true,"color":"dark_aqua"},{"text":"[","bold":true,"color":"green"},{"text":"Protect your banner!","bold":true,"color":"gold"},{"text":" ","color":"gold"},{"text":"Keep in mind not to completely surround it as you have to bring the opponent's banner here as well!\nUse the snow to start building!","color":"aqua","bold":false},{"text":"]","bold":true,"color":"green"}]

# Equipment
clear @a[gamemode=adventure] stone_sword
item replace entity @a[gamemode=adventure,team=blue] armor.chest with minecraft:leather_chestplate{Unbreakable:1,Enchantments:[{id:"binding_curse",lvl:1},{id:"minecraft:protection",lvl:1}],display:{color:411593,Name:'{"text":"Cool Shirt"}'},HideFlags:63} 1
item replace entity @a[gamemode=adventure,team=red] armor.chest with minecraft:leather_chestplate{Unbreakable:1,Enchantments:[{id:"binding_curse",lvl:1},{id:"minecraft:protection",lvl:1}],display:{color:16711680,Name:'{"text":"Not-so-Cool Shirt"}'},HideFlags:63} 1
clear @a firework_rocket

# Player handling
stopsound @a
execute as @a at @s run playsound minecraft:music_disc.mall player @s ~ ~ ~ 10000 1 1
tag @a add phase.2
scoreboard objectives modify timeDisplay displayname {"text":"Phase 2","color":"yellow"}

# Make blocks placeable & get tools
execute as @a[gamemode=adventure] run function bannerbattle:phase2/replace_blocks

# Misc
clone 0 120 157 0 121 158 8 26 37
clone 1 120 158 1 121 157 8 26 -22
tp @e[tag=z] ~ -100 ~
kill @e[type=item,nbt={Item:{tag:{MobDrop:1b}}}]
execute as @e[tag=jump] run data merge entity @s {CustomNameVisible:0}
bossbar set mobs visible false
setblock 8 27 -29 minecraft:birch_sign[rotation=0,waterlogged=false]{Color:"green",GlowingText:1b,Text1:'{"clickEvent":{"action":"run_command","value":"function bannerbattle:phase2/ready"},"text":""}',Text2:'{"text":"Ready"}',Text3:'{"text":""}',Text4:'{"text":""}'}
setblock 8 27 45 minecraft:birch_sign[rotation=8,waterlogged=false]{Color:"green",GlowingText:1b,Text1:'{"clickEvent":{"action":"run_command","value":"function bannerbattle:phase2/ready"},"text":""}',Text2:'{"text":"Ready"}',Text3:'{"text":""}',Text4:'{"text":""}'}
